﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr134_1
{
    // Класс с многомерным индексатором: 
    class MyClass {
        // Закрытое целочисленное поле: 
        private int code;
        // Конструктор с целочисленным аргументом: 
        public MyClass(int n) { 
            // Значение поля: 
            code = n;
        }
        // Переопределение метода ToString(): 
        public override string ToString(){
            // Результат метода:
            return "Поле code объекта: " + code;
        }
        // Многомерный индексатор:
        public char this[string a, int i, string b, int j] {
            // Метод вызывается при считывании значения 
            // выражения с проиндексированным объектом: 
            get {
                // Значение выражения: 
                return (char)(a[i] - b[j] + code);
            }
            // Метод вызывается при присваивании значения 
            // выражению с проиндексированным объектом: 
            set {
                // Значение поля: 
                code = value - (a[i] - b[j]);
            }
        }
    }

    // Класс с главным методом: 
    class Program
    {
        // Главный метод:
        static void Main()
        {
            // Создание объекта:
            MyClass obj = new MyClass('A');
            // Проверка значения поля объекта:
            Console.WriteLine(obj);
            // Текстовые переменные: 
            string a = "Alpha", b = "Bravo";
            // Целочисленные переменные: 
            int i = 2, j = 4;
            // Использование индексатора:
            Console.WriteLine("obj[\"{0}\", {1}, \"{2}\", {3}] = {4}", a, i, b, j, obj[a, i, b, j]); 
            // Использование индексатора: 
            obj[a, i, b, j] = 'F';
            // Проверка значения поля объекта:
            Console.WriteLine(obj);
            // Использование индексатора:
            Console.WriteLine("obj[\"{0}\", {1}, \"{2}\", {3}] = {4}", a, i, b, j, obj[a, i, b, j]);
            // Новые значения переменных:
            a = "Charlie";
            i = 1;
            j = 2;
            // Использование индексатора:
            Console.WriteLine ("obj[\"{0}\", {1}, \"{2}\", {3}] = {4}", a, i, b, j, obj[a, i, b, j]);
            // Задержка:
            Console.ReadLine();
        }
    }
}
